/* File: linalg_utilsmodule.c
 * This file is auto-generated with f2py (version:2).
 * f2py is a Fortran to Python Interface Generator (FPIG), Second Edition,
 * written by Pearu Peterson <pearu@cens.ioc.ee>.
 * See http://cens.ioc.ee/projects/f2py2e/
 * Generation date: Sat Dec 17 12:22:00 2016
 * $Revision:$
 * $Date:$
 * Do not edit this file directly unless you know what you are doing!!!
 */

#ifdef __cplusplus
extern "C" {
#endif

/*********************** See f2py2e/cfuncs.py: includes ***********************/
#include "Python.h"
#include <stdarg.h>
#include "fortranobject.h"
#include <string.h>
#include <setjmp.h>
#include <math.h>

/**************** See f2py2e/rules.py: mod_rules['modulebody'] ****************/
static PyObject *linalg_utils_error;
static PyObject *linalg_utils_module;

/*********************** See f2py2e/cfuncs.py: typedefs ***********************/
typedef char * string;

/****************** See f2py2e/cfuncs.py: typedefs_generated ******************/
typedef double(*cb_cov_fun_in_diag_call__user__routines_typedef)(double *,int *);

/********************** See f2py2e/cfuncs.py: cppmacros **********************/
\
#define FAILNULL(p) do {                                            \
    if ((p) == NULL) {                                              \
        PyErr_SetString(PyExc_MemoryError, "NULL pointer found");   \
        goto capi_fail;                                             \
    }                                                               \
} while (0)

#define STRINGMALLOC(str,len)\
  if ((str = (string)malloc(sizeof(char)*(len+1))) == NULL) {\
    PyErr_SetString(PyExc_MemoryError, "out of memory");\
    goto capi_fail;\
  } else {\
    (str)[len] = '\0';\
  }

#define PRINTPYOBJERR(obj)\
  fprintf(stderr,"linalg_utils.error is related to ");\
  PyObject_Print((PyObject *)obj,stderr,Py_PRINT_RAW);\
  fprintf(stderr,"\n");

#define GETSCALARFROMPYTUPLE(tuple,index,var,ctype,mess) {\
    if ((capi_tmp = PyTuple_GetItem((tuple),(index)))==NULL) goto capi_fail;\
    if (!(ctype ## _from_pyobj((var),capi_tmp,mess)))\
      goto capi_fail;\
  }

#ifdef DEBUGCFUNCS
#define CFUNCSMESS(mess) fprintf(stderr,"debug-capi:"mess);
#define CFUNCSMESSPY(mess,obj) CFUNCSMESS(mess) \
  PyObject_Print((PyObject *)obj,stderr,Py_PRINT_RAW);\
  fprintf(stderr,"\n");
#else
#define CFUNCSMESS(mess)
#define CFUNCSMESSPY(mess,obj)
#endif

#if defined(PREPEND_FORTRAN)
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F
#else
#define F_FUNC(f,F) _##f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F##_
#else
#define F_FUNC(f,F) _##f##_
#endif
#endif
#else
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F
#else
#define F_FUNC(f,F) f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F##_
#else
#define F_FUNC(f,F) f##_
#endif
#endif
#endif
#if defined(UNDERSCORE_G77)
#define F_FUNC_US(f,F) F_FUNC(f##_,F##_)
#else
#define F_FUNC_US(f,F) F_FUNC(f,F)
#endif

#define rank(var) var ## _Rank
#define shape(var,dim) var ## _Dims[dim]
#define old_rank(var) (PyArray_NDIM((PyArrayObject *)(capi_ ## var ## _tmp)))
#define old_shape(var,dim) PyArray_DIM(((PyArrayObject *)(capi_ ## var ## _tmp)),dim)
#define fshape(var,dim) shape(var,rank(var)-dim-1)
#define len(var) shape(var,0)
#define flen(var) fshape(var,0)
#define old_size(var) PyArray_SIZE((PyArrayObject *)(capi_ ## var ## _tmp))
/* #define index(i) capi_i ## i */
#define slen(var) capi_ ## var ## _len
#define size(var, ...) f2py_size((PyArrayObject *)(capi_ ## var ## _tmp), ## __VA_ARGS__, -1)

#define CHECKSCALAR(check,tcheck,name,show,var)\
  if (!(check)) {\
    char errstring[256];\
    sprintf(errstring, "%s: "show, "("tcheck") failed for "name, var);\
    PyErr_SetString(linalg_utils_error,errstring);\
    /*goto capi_fail;*/\
  } else 
#ifndef max
#define max(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef min
#define min(a,b) ((a < b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b) ((a < b) ? (a) : (b))
#endif

#define SWAP(a,b,t) {\
  t *c;\
  c = a;\
  a = b;\
  b = c;}

#define STRINGFREE(str) do {if (!(str == NULL)) free(str);} while (0)

#define STRINGCOPYN(to,from,buf_size)                           \
    do {                                                        \
        int _m = (buf_size);                                    \
        char *_to = (to);                                       \
        char *_from = (from);                                   \
        FAILNULL(_to); FAILNULL(_from);                         \
        (void)strncpy(_to, _from, sizeof(char)*_m);             \
        _to[_m-1] = '\0';                                      \
        /* Padding with spaces instead of nulls */              \
        for (_m -= 2; _m >= 0 && _to[_m] == '\0'; _m--) {      \
            _to[_m] = ' ';                                      \
        }                                                       \
    } while (0)


/************************ See f2py2e/cfuncs.py: cfuncs ************************/
static int f2py_size(PyArrayObject* var, ...)
{
  npy_int sz = 0;
  npy_int dim;
  npy_int rank;
  va_list argp;
  va_start(argp, var);
  dim = va_arg(argp, npy_int);
  if (dim==-1)
    {
      sz = PyArray_SIZE(var);
    }
  else
    {
      rank = PyArray_NDIM(var);
      if (dim>=1 && dim<=rank)
        sz = PyArray_DIM(var, dim-1);
      else
        fprintf(stderr, "f2py_size: 2nd argument value=%d fails to satisfy 1<=value<=%d. Result will be 0.\n", dim, rank);
    }
  va_end(argp);
  return sz;
}

static int double_from_pyobj(double* v,PyObject *obj,const char *errmess) {
  PyObject* tmp = NULL;
  if (PyFloat_Check(obj)) {
#ifdef __sgi
    *v = PyFloat_AsDouble(obj);
#else
    *v = PyFloat_AS_DOUBLE(obj);
#endif
    return 1;
  }
  tmp = PyNumber_Float(obj);
  if (tmp) {
#ifdef __sgi
    *v = PyFloat_AsDouble(tmp);
#else
    *v = PyFloat_AS_DOUBLE(tmp);
#endif
    Py_DECREF(tmp);
    return 1;
  }
  if (PyComplex_Check(obj))
    tmp = PyObject_GetAttrString(obj,"real");
  else if (PyString_Check(obj) || PyUnicode_Check(obj))
    /*pass*/;
  else if (PySequence_Check(obj))
    tmp = PySequence_GetItem(obj,0);
  if (tmp) {
    PyErr_Clear();
    if (double_from_pyobj(v,tmp,errmess)) {Py_DECREF(tmp); return 1;}
    Py_DECREF(tmp);
  }
  {
    PyObject* err = PyErr_Occurred();
    if (err==NULL) err = linalg_utils_error;
    PyErr_SetString(err,errmess);
  }
  return 0;
}

static int create_cb_arglist(PyObject* fun,PyTupleObject* xa,const int maxnofargs,const int nofoptargs,int *nofargs,PyTupleObject **args,const char *errmess) {
  PyObject *tmp = NULL;
  PyObject *tmp_fun = NULL;
  int tot,opt,ext,siz,i,di=0;
  CFUNCSMESS("create_cb_arglist\n");
  tot=opt=ext=siz=0;
  /* Get the total number of arguments */
  if (PyFunction_Check(fun))
    tmp_fun = fun;
  else {
    di = 1;
    if (PyObject_HasAttrString(fun,"im_func")) {
      tmp_fun = PyObject_GetAttrString(fun,"im_func");
    }
    else if (PyObject_HasAttrString(fun,"__call__")) {
      tmp = PyObject_GetAttrString(fun,"__call__");
      if (PyObject_HasAttrString(tmp,"im_func"))
        tmp_fun = PyObject_GetAttrString(tmp,"im_func");
      else {
        tmp_fun = fun; /* built-in function */
        tot = maxnofargs;
        if (xa != NULL)
          tot += PyTuple_Size((PyObject *)xa);
      }
      Py_XDECREF(tmp);
    }
    else if (PyFortran_Check(fun) || PyFortran_Check1(fun)) {
      tot = maxnofargs;
      if (xa != NULL)
        tot += PyTuple_Size((PyObject *)xa);
      tmp_fun = fun;
    }
    else if (F2PyCapsule_Check(fun)) {
      tot = maxnofargs;
      if (xa != NULL)
        ext = PyTuple_Size((PyObject *)xa);
      if(ext>0) {
        fprintf(stderr,"extra arguments tuple cannot be used with CObject call-back\n");
        goto capi_fail;
      }
      tmp_fun = fun;
    }
  }
if (tmp_fun==NULL) {
fprintf(stderr,"Call-back argument must be function|instance|instance.__call__|f2py-function but got %s.\n",(fun==NULL?"NULL":Py_TYPE(fun)->tp_name));
goto capi_fail;
}
#if PY_VERSION_HEX >= 0x03000000
  if (PyObject_HasAttrString(tmp_fun,"__code__")) {
    if (PyObject_HasAttrString(tmp = PyObject_GetAttrString(tmp_fun,"__code__"),"co_argcount"))
#else
  if (PyObject_HasAttrString(tmp_fun,"func_code")) {
    if (PyObject_HasAttrString(tmp = PyObject_GetAttrString(tmp_fun,"func_code"),"co_argcount"))
#endif
      tot = PyInt_AsLong(PyObject_GetAttrString(tmp,"co_argcount")) - di;
    Py_XDECREF(tmp);
  }
  /* Get the number of optional arguments */
#if PY_VERSION_HEX >= 0x03000000
  if (PyObject_HasAttrString(tmp_fun,"__defaults__")) {
    if (PyTuple_Check(tmp = PyObject_GetAttrString(tmp_fun,"__defaults__")))
#else
  if (PyObject_HasAttrString(tmp_fun,"func_defaults")) {
    if (PyTuple_Check(tmp = PyObject_GetAttrString(tmp_fun,"func_defaults")))
#endif
      opt = PyTuple_Size(tmp);
    Py_XDECREF(tmp);
  }
  /* Get the number of extra arguments */
  if (xa != NULL)
    ext = PyTuple_Size((PyObject *)xa);
  /* Calculate the size of call-backs argument list */
  siz = MIN(maxnofargs+ext,tot);
  *nofargs = MAX(0,siz-ext);
#ifdef DEBUGCFUNCS
  fprintf(stderr,"debug-capi:create_cb_arglist:maxnofargs(-nofoptargs),tot,opt,ext,siz,nofargs=%d(-%d),%d,%d,%d,%d,%d\n",maxnofargs,nofoptargs,tot,opt,ext,siz,*nofargs);
#endif
  if (siz<tot-opt) {
    fprintf(stderr,"create_cb_arglist: Failed to build argument list (siz) with enough arguments (tot-opt) required by user-supplied function (siz,tot,opt=%d,%d,%d).\n",siz,tot,opt);
    goto capi_fail;
  }
  /* Initialize argument list */
  *args = (PyTupleObject *)PyTuple_New(siz);
  for (i=0;i<*nofargs;i++) {
    Py_INCREF(Py_None);
    PyTuple_SET_ITEM((PyObject *)(*args),i,Py_None);
  }
  if (xa != NULL)
    for (i=(*nofargs);i<siz;i++) {
      tmp = PyTuple_GetItem((PyObject *)xa,i-(*nofargs));
      Py_INCREF(tmp);
      PyTuple_SET_ITEM(*args,i,tmp);
    }
  CFUNCSMESS("create_cb_arglist-end\n");
  return 1;
capi_fail:
  if ((PyErr_Occurred())==NULL)
    PyErr_SetString(linalg_utils_error,errmess);
  return 0;
}

static int int_from_pyobj(int* v,PyObject *obj,const char *errmess) {
  PyObject* tmp = NULL;
  if (PyInt_Check(obj)) {
    *v = (int)PyInt_AS_LONG(obj);
    return 1;
  }
  tmp = PyNumber_Int(obj);
  if (tmp) {
    *v = PyInt_AS_LONG(tmp);
    Py_DECREF(tmp);
    return 1;
  }
  if (PyComplex_Check(obj))
    tmp = PyObject_GetAttrString(obj,"real");
  else if (PyString_Check(obj) || PyUnicode_Check(obj))
    /*pass*/;
  else if (PySequence_Check(obj))
    tmp = PySequence_GetItem(obj,0);
  if (tmp) {
    PyErr_Clear();
    if (int_from_pyobj(v,tmp,errmess)) {Py_DECREF(tmp); return 1;}
    Py_DECREF(tmp);
  }
  {
    PyObject* err = PyErr_Occurred();
    if (err==NULL) err = linalg_utils_error;
    PyErr_SetString(err,errmess);
  }
  return 0;
}

static int string_from_pyobj(string *str,int *len,const string inistr,PyObject *obj,const char *errmess) {
  PyArrayObject *arr = NULL;
  PyObject *tmp = NULL;
#ifdef DEBUGCFUNCS
fprintf(stderr,"string_from_pyobj(str='%s',len=%d,inistr='%s',obj=%p)\n",(char*)str,*len,(char *)inistr,obj);
#endif
  if (obj == Py_None) {
    if (*len == -1)
      *len = strlen(inistr); /* Will this cause problems? */
    STRINGMALLOC(*str,*len);
    STRINGCOPYN(*str,inistr,*len+1);
    return 1;
  }
  if (PyArray_Check(obj)) {
    if ((arr = (PyArrayObject *)obj) == NULL)
      goto capi_fail;
    if (!ISCONTIGUOUS(arr)) {
      PyErr_SetString(PyExc_ValueError,"array object is non-contiguous.");
      goto capi_fail;
    }
    if (*len == -1)
      *len = (PyArray_ITEMSIZE(arr))*PyArray_SIZE(arr);
    STRINGMALLOC(*str,*len);
    STRINGCOPYN(*str,PyArray_DATA(arr),*len+1);
    return 1;
  }
  if (PyString_Check(obj)) {
    tmp = obj;
    Py_INCREF(tmp);
  }
#if PY_VERSION_HEX >= 0x03000000
  else if (PyUnicode_Check(obj)) {
    tmp = PyUnicode_AsASCIIString(obj);
  }
  else {
    PyObject *tmp2;
    tmp2 = PyObject_Str(obj);
    if (tmp2) {
      tmp = PyUnicode_AsASCIIString(tmp2);
      Py_DECREF(tmp2);
    }
    else {
      tmp = NULL;
    }
  }
#else
  else {
    tmp = PyObject_Str(obj);
  }
#endif
  if (tmp == NULL) goto capi_fail;
  if (*len == -1)
    *len = PyString_GET_SIZE(tmp);
  STRINGMALLOC(*str,*len);
  STRINGCOPYN(*str,PyString_AS_STRING(tmp),*len+1);
  Py_DECREF(tmp);
  return 1;
capi_fail:
  Py_XDECREF(tmp);
  {
    PyObject* err = PyErr_Occurred();
    if (err==NULL) err = linalg_utils_error;
    PyErr_SetString(err,errmess);
  }
  return 0;
}


/********************* See f2py2e/cfuncs.py: userincludes *********************/
/*need_userincludes*/

/********************* See f2py2e/capi_rules.py: usercode *********************/


/* See f2py2e/rules.py */
extern void F_FUNC_US(remove_duplicates,REMOVE_DUPLICATES)(double*,int*,int*,int*,int*,int*,int*,double*,int*);
extern void F_FUNC_US(check_repeats,CHECK_REPEATS)(double*,double*,double*,int*,int*,int*,double*,int*,int*);
extern void F_FUNC_US(diag_call,DIAG_CALL)(double*,int*,int*,double*,cb_cov_fun_in_diag_call__user__routines_typedef);
extern void F_FUNC_US(basis_diag_call,BASIS_DIAG_CALL)(double*,double*,int*,int*);
extern void F_FUNC_US(gp_array_logp,GP_ARRAY_LOGP)(double*,double*,double*,int*,double*,int*);
extern void F_FUNC(asqs,ASQS)(double*,double*,int*,int*,int*,int*);
extern void F_FUNC_US(dcopy_wrap,DCOPY_WRAP)(double*,double*,int*);
extern void F_FUNC_US(dtrmm_wrap,DTRMM_WRAP)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t);
extern void F_FUNC_US(dtrsm_wrap,DTRSM_WRAP)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t);
extern void F_FUNC_US(dpotrf_wrap,DPOTRF_WRAP)(double*,int*,int*);
extern void F_FUNC_US(dchdc_wrap,DCHDC_WRAP)(double*,int*,double*,int*,int*);
extern void F_FUNC_US(dpotrs_wrap,DPOTRS_WRAP)(double*,double*,int*,int*,int*,string,size_t);
/*eof externroutines*/

/******************** See f2py2e/capi_rules.py: usercode1 ********************/


/******************* See f2py2e/cb_rules.py: buildcallback *******************/

/****************** cb_cov_fun_in_diag_call__user__routines ******************/
PyObject *cb_cov_fun_in_diag_call__user__routines_capi = NULL;/*was Py_None*/
PyTupleObject *cb_cov_fun_in_diag_call__user__routines_args_capi = NULL;
int cb_cov_fun_in_diag_call__user__routines_nofargs = 0;
jmp_buf cb_cov_fun_in_diag_call__user__routines_jmpbuf;
/*typedef double(*cb_cov_fun_in_diag_call__user__routines_typedef)(double *,int *);*/
static double cb_cov_fun_in_diag_call__user__routines (double *xe,int *ndim_cb_capi) {
  PyTupleObject *capi_arglist = cb_cov_fun_in_diag_call__user__routines_args_capi;
  PyObject *capi_return = NULL;
  PyObject *capi_tmp = NULL;
  int capi_j,capi_i = 0;
  int capi_longjmp_ok = 1;
/*decl*/
  double return_value;
  int ndim=(*ndim_cb_capi);
  npy_intp xe_Dims[2] = {-1, -1};
#ifdef F2PY_REPORT_ATEXIT
f2py_cb_start_clock();
#endif
  CFUNCSMESS("cb:Call-back function cb_cov_fun_in_diag_call__user__routines (maxnofargs=1(-0))\n");
  CFUNCSMESSPY("cb:cb_cov_fun_in_diag_call__user__routines_capi=",cb_cov_fun_in_diag_call__user__routines_capi);
  if (cb_cov_fun_in_diag_call__user__routines_capi==NULL) {
    capi_longjmp_ok = 0;
    cb_cov_fun_in_diag_call__user__routines_capi = PyObject_GetAttrString(linalg_utils_module,"cov_fun");
  }
  if (cb_cov_fun_in_diag_call__user__routines_capi==NULL) {
    PyErr_SetString(linalg_utils_error,"cb: Callback cov_fun not defined (as an argument or module linalg_utils attribute).\n");
    goto capi_fail;
  }
  if (F2PyCapsule_Check(cb_cov_fun_in_diag_call__user__routines_capi)) {
  cb_cov_fun_in_diag_call__user__routines_typedef cb_cov_fun_in_diag_call__user__routines_cptr;
  cb_cov_fun_in_diag_call__user__routines_cptr = F2PyCapsule_AsVoidPtr(cb_cov_fun_in_diag_call__user__routines_capi);
  return_value=(*cb_cov_fun_in_diag_call__user__routines_cptr)(xe,ndim_cb_capi);
    return return_value;
  }
  if (capi_arglist==NULL) {
    capi_longjmp_ok = 0;
    capi_tmp = PyObject_GetAttrString(linalg_utils_module,"cov_fun_extra_args");
    if (capi_tmp) {
      capi_arglist = (PyTupleObject *)PySequence_Tuple(capi_tmp);
      if (capi_arglist==NULL) {
        PyErr_SetString(linalg_utils_error,"Failed to convert linalg_utils.cov_fun_extra_args to tuple.\n");
        goto capi_fail;
      }
    } else {
      PyErr_Clear();
      capi_arglist = (PyTupleObject *)Py_BuildValue("()");
    }
  }
  if (capi_arglist == NULL) {
    PyErr_SetString(linalg_utils_error,"Callback cov_fun argument list is not set.\n");
    goto capi_fail;
  }
/*setdims*/
  xe_Dims[0]=1,xe_Dims[1]=ndim;
/*pyobjfrom*/
  if (cb_cov_fun_in_diag_call__user__routines_nofargs>capi_i) {
    PyArrayObject *tmp_arr = (PyArrayObject *)PyArray_New(&PyArray_Type,2,xe_Dims,NPY_DOUBLE,NULL,(char*)xe,0,NPY_ARRAY_FARRAY,NULL); /*XXX: Hmm, what will destroy this array??? */


    if (tmp_arr==NULL)
      goto capi_fail;
    if (PyTuple_SetItem((PyObject *)capi_arglist,capi_i++,(PyObject *)tmp_arr))
      goto capi_fail;
}
  CFUNCSMESSPY("cb:capi_arglist=",capi_arglist);
  CFUNCSMESS("cb:Call-back calling Python function cov_fun.\n");
#ifdef F2PY_REPORT_ATEXIT
f2py_cb_start_call_clock();
#endif
  capi_return = PyObject_CallObject(cb_cov_fun_in_diag_call__user__routines_capi,(PyObject *)capi_arglist);
#ifdef F2PY_REPORT_ATEXIT
f2py_cb_stop_call_clock();
#endif
  CFUNCSMESSPY("cb:capi_return=",capi_return);
  if (capi_return == NULL) {
    fprintf(stderr,"capi_return is NULL\n");
    goto capi_fail;
  }
  if (capi_return == Py_None) {
    Py_DECREF(capi_return);
    capi_return = Py_BuildValue("()");
  }
  else if (!PyTuple_Check(capi_return)) {
    capi_return = Py_BuildValue("(N)",capi_return);
  }
  capi_j = PyTuple_Size(capi_return);
  capi_i = 0;
/*frompyobj*/
  if (capi_j>capi_i)
    GETSCALARFROMPYTUPLE(capi_return,capi_i++,&return_value,double,"double_from_pyobj failed in converting return_value of call-back function cb_cov_fun_in_diag_call__user__routines to C double\n");
  CFUNCSMESS("cb:cb_cov_fun_in_diag_call__user__routines:successful\n");
  Py_DECREF(capi_return);
#ifdef F2PY_REPORT_ATEXIT
f2py_cb_stop_clock();
#endif
  goto capi_return_pt;
capi_fail:
  fprintf(stderr,"Call-back cb_cov_fun_in_diag_call__user__routines failed.\n");
  Py_XDECREF(capi_return);
  if (capi_longjmp_ok)
    longjmp(cb_cov_fun_in_diag_call__user__routines_jmpbuf,-1);
capi_return_pt:
  ;
  return return_value;
}
/*************** end of cb_cov_fun_in_diag_call__user__routines ***************/


/*********************** See f2py2e/rules.py: buildapi ***********************/

/***************************** remove_duplicates *****************************/
static char doc_f2py_rout_linalg_utils_remove_duplicates[] = "\
nr,rf,rt,nu,xu,ui = remove_duplicates(x)\n\nWrapper for ``remove_duplicates``.\
\n\nParameters\n----------\n"
"x : input rank-2 array('d') with bounds (n,nd)\n"
"\nReturns\n-------\n"
"nr : int\n"
"rf : rank-1 array('i') with bounds (n)\n"
"rt : rank-1 array('i') with bounds (n)\n"
"nu : int\n"
"xu : rank-2 array('d') with bounds (n,nd)\n"
"ui : rank-1 array('i') with bounds (n)";
/* extern void F_FUNC_US(remove_duplicates,REMOVE_DUPLICATES)(double*,int*,int*,int*,int*,int*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_remove_duplicates(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,int*,int*,int*,int*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[2] = {-1, -1};
  const int x_Rank = 2;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int n = 0;
  int nd = 0;
  int nr = 0;
  int *rf = NULL;
  npy_intp rf_Dims[1] = {-1};
  const int rf_Rank = 1;
  PyArrayObject *capi_rf_tmp = NULL;
  int capi_rf_intent = 0;
  int *rt = NULL;
  npy_intp rt_Dims[1] = {-1};
  const int rt_Rank = 1;
  PyArrayObject *capi_rt_tmp = NULL;
  int capi_rt_intent = 0;
  int nu = 0;
  double *xu = NULL;
  npy_intp xu_Dims[2] = {-1, -1};
  const int xu_Rank = 2;
  PyArrayObject *capi_xu_tmp = NULL;
  int capi_xu_intent = 0;
  int *ui = NULL;
  npy_intp ui_Dims[1] = {-1};
  const int ui_Rank = 1;
  PyArrayObject *capi_ui_tmp = NULL;
  int capi_ui_intent = 0;
  static char *capi_kwlist[] = {"x",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.remove_duplicates",\
    capi_kwlist,&x_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable nu */
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    x = (double *)(PyArray_DATA(capi_x_tmp));

  /* Processing variable nr */
  /* Processing variable nd */
  nd = shape(x,1);
  CHECKSCALAR(shape(x,1)==nd,"shape(x,1)==nd","hidden nd","remove_duplicates:nd=%d",nd) {
  /* Processing variable n */
  n = shape(x,0);
  CHECKSCALAR(shape(x,0)==n,"shape(x,0)==n","hidden n","remove_duplicates:n=%d",n) {
  /* Processing variable rf */
  rf_Dims[0]=n;
  capi_rf_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_rf_tmp = array_from_pyobj(NPY_INT,rf_Dims,rf_Rank,capi_rf_intent,Py_None);
  if (capi_rf_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `rf' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    rf = (int *)(PyArray_DATA(capi_rf_tmp));

  /* Processing variable ui */
  ui_Dims[0]=n;
  capi_ui_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_ui_tmp = array_from_pyobj(NPY_INT,ui_Dims,ui_Rank,capi_ui_intent,Py_None);
  if (capi_ui_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `ui' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    ui = (int *)(PyArray_DATA(capi_ui_tmp));

  /* Processing variable xu */
  xu_Dims[0]=n,xu_Dims[1]=nd;
  capi_xu_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_xu_tmp = array_from_pyobj(NPY_DOUBLE,xu_Dims,xu_Rank,capi_xu_intent,Py_None);
  if (capi_xu_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `xu' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    xu = (double *)(PyArray_DATA(capi_xu_tmp));

  /* Processing variable rt */
  rt_Dims[0]=n;
  capi_rt_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_rt_tmp = array_from_pyobj(NPY_INT,rt_Dims,rt_Rank,capi_rt_intent,Py_None);
  if (capi_rt_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `rt' of linalg_utils.remove_duplicates to C/Fortran array" );
  } else {
    rt = (int *)(PyArray_DATA(capi_rt_tmp));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(x,&n,&nd,&nr,rf,rt,&nu,xu,ui);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("iNNiNN",nr,capi_rf_tmp,capi_rt_tmp,nu,capi_xu_tmp,capi_ui_tmp);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  }  /*if (capi_rt_tmp == NULL) ... else of rt*/
  /* End of cleaning variable rt */
  }  /*if (capi_xu_tmp == NULL) ... else of xu*/
  /* End of cleaning variable xu */
  }  /*if (capi_ui_tmp == NULL) ... else of ui*/
  /* End of cleaning variable ui */
  }  /*if (capi_rf_tmp == NULL) ... else of rf*/
  /* End of cleaning variable rf */
  } /*CHECKSCALAR(shape(x,0)==n)*/
  /* End of cleaning variable n */
  } /*CHECKSCALAR(shape(x,1)==nd)*/
  /* End of cleaning variable nd */
  /* End of cleaning variable nr */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  /* End of cleaning variable nu */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/************************** end of remove_duplicates **************************/

/******************************* check_repeats *******************************/
static char doc_f2py_rout_linalg_utils_check_repeats[] = "\
f,new_indices,n_new_indices = check_repeats(x,x_sofar,f_sofar)\n\nWrapper for ``check_repeats``.\
\n\nParameters\n----------\n"
"x : input rank-2 array('d') with bounds (n,n_dim)\n"
"x_sofar : input rank-2 array('d') with bounds (n_sofar,n_dim)\n"
"f_sofar : input rank-1 array('d') with bounds (n_sofar)\n"
"\nReturns\n-------\n"
"f : rank-1 array('d') with bounds (n)\n"
"new_indices : rank-1 array('i') with bounds (n)\n"
"n_new_indices : int";
/* extern void F_FUNC_US(check_repeats,CHECK_REPEATS)(double*,double*,double*,int*,int*,int*,double*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_check_repeats(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,int*,int*,int*,double*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[2] = {-1, -1};
  const int x_Rank = 2;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  double *x_sofar = NULL;
  npy_intp x_sofar_Dims[2] = {-1, -1};
  const int x_sofar_Rank = 2;
  PyArrayObject *capi_x_sofar_tmp = NULL;
  int capi_x_sofar_intent = 0;
  PyObject *x_sofar_capi = Py_None;
  double *f_sofar = NULL;
  npy_intp f_sofar_Dims[1] = {-1};
  const int f_sofar_Rank = 1;
  PyArrayObject *capi_f_sofar_tmp = NULL;
  int capi_f_sofar_intent = 0;
  PyObject *f_sofar_capi = Py_None;
  int n = 0;
  int n_dim = 0;
  int n_sofar = 0;
  double *f = NULL;
  npy_intp f_Dims[1] = {-1};
  const int f_Rank = 1;
  PyArrayObject *capi_f_tmp = NULL;
  int capi_f_intent = 0;
  int *new_indices = NULL;
  npy_intp new_indices_Dims[1] = {-1};
  const int new_indices_Rank = 1;
  PyArrayObject *capi_new_indices_tmp = NULL;
  int capi_new_indices_intent = 0;
  int n_new_indices = 0;
  static char *capi_kwlist[] = {"x","x_sofar","f_sofar",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO:linalg_utils.check_repeats",\
    capi_kwlist,&x_capi,&x_sofar_capi,&f_sofar_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    x = (double *)(PyArray_DATA(capi_x_tmp));

  /* Processing variable n_new_indices */
  /* Processing variable n_dim */
  n_dim = shape(x,1);
  /* Processing variable n */
  n = shape(x,0);
  /* Processing variable x_sofar */
  x_sofar_Dims[1]=n_dim;
  capi_x_sofar_intent |= F2PY_INTENT_IN;
  capi_x_sofar_tmp = array_from_pyobj(NPY_DOUBLE,x_sofar_Dims,x_sofar_Rank,capi_x_sofar_intent,x_sofar_capi);
  if (capi_x_sofar_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `x_sofar' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    x_sofar = (double *)(PyArray_DATA(capi_x_sofar_tmp));

  /* Processing variable n_sofar */
  n_sofar = shape(x_sofar,0);
  /* Processing variable new_indices */
  new_indices_Dims[0]=n;
  capi_new_indices_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_new_indices_tmp = array_from_pyobj(NPY_INT,new_indices_Dims,new_indices_Rank,capi_new_indices_intent,Py_None);
  if (capi_new_indices_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `new_indices' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    new_indices = (int *)(PyArray_DATA(capi_new_indices_tmp));

  /* Processing variable f */
  f_Dims[0]=n;
  capi_f_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_f_tmp = array_from_pyobj(NPY_DOUBLE,f_Dims,f_Rank,capi_f_intent,Py_None);
  if (capi_f_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `f' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    f = (double *)(PyArray_DATA(capi_f_tmp));

  /* Processing variable f_sofar */
  f_sofar_Dims[0]=n_sofar;
  capi_f_sofar_intent |= F2PY_INTENT_IN;
  capi_f_sofar_tmp = array_from_pyobj(NPY_DOUBLE,f_sofar_Dims,f_sofar_Rank,capi_f_sofar_intent,f_sofar_capi);
  if (capi_f_sofar_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 3rd argument `f_sofar' of linalg_utils.check_repeats to C/Fortran array" );
  } else {
    f_sofar = (double *)(PyArray_DATA(capi_f_sofar_tmp));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(x,x_sofar,f_sofar,&n,&n_dim,&n_sofar,f,new_indices,&n_new_indices);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("NNi",capi_f_tmp,capi_new_indices_tmp,n_new_indices);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_f_sofar_tmp!=f_sofar_capi) {
    Py_XDECREF(capi_f_sofar_tmp); }
  }  /*if (capi_f_sofar_tmp == NULL) ... else of f_sofar*/
  /* End of cleaning variable f_sofar */
  }  /*if (capi_f_tmp == NULL) ... else of f*/
  /* End of cleaning variable f */
  }  /*if (capi_new_indices_tmp == NULL) ... else of new_indices*/
  /* End of cleaning variable new_indices */
  /* End of cleaning variable n_sofar */
  if((PyObject *)capi_x_sofar_tmp!=x_sofar_capi) {
    Py_XDECREF(capi_x_sofar_tmp); }
  }  /*if (capi_x_sofar_tmp == NULL) ... else of x_sofar*/
  /* End of cleaning variable x_sofar */
  /* End of cleaning variable n */
  /* End of cleaning variable n_dim */
  /* End of cleaning variable n_new_indices */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/**************************** end of check_repeats ****************************/

/********************************* diag_call *********************************/
static char doc_f2py_rout_linalg_utils_diag_call[] = "\
v = diag_call(x,cov_fun,[cov_fun_extra_args])\n\nWrapper for ``diag_call``.\
\n\nParameters\n----------\n"
"x : input rank-2 array('d') with bounds (n,ndim)\n"
"cov_fun : call-back function\n"
"\nOther Parameters\n----------------\n"
"cov_fun_extra_args : input tuple, optional\n    Default: ()\n"
"\nReturns\n-------\n"
"v : rank-1 array('d') with bounds (n)\n"
"\nNotes\n-----\nCall-back functions::\n\n"
"  def cov_fun(xe): return q\n\
  Required arguments:\n"
"    xe : input rank-2 array('d') with bounds (1,ndim)\n"
"  Return objects:\n"
"    q : float";
/* extern void F_FUNC_US(diag_call,DIAG_CALL)(double*,int*,int*,double*,cb_cov_fun_in_diag_call__user__routines_typedef); */
static PyObject *f2py_rout_linalg_utils_diag_call(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,int*,double*,cb_cov_fun_in_diag_call__user__routines_typedef)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[2] = {-1, -1};
  const int x_Rank = 2;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  int n = 0;
  int ndim = 0;
  double *v = NULL;
  npy_intp v_Dims[1] = {-1};
  const int v_Rank = 1;
  PyArrayObject *capi_v_tmp = NULL;
  int capi_v_intent = 0;
  PyObject *cov_fun_capi = Py_None;
  PyTupleObject *cov_fun_xa_capi = NULL;
  PyTupleObject *cov_fun_args_capi = NULL;
  int cov_fun_nofargs_capi = 0;
  cb_cov_fun_in_diag_call__user__routines_typedef cov_fun_cptr;
  static char *capi_kwlist[] = {"x","cov_fun","cov_fun_extra_args",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO|O!:linalg_utils.diag_call",\
    capi_kwlist,&x_capi,&cov_fun_capi,&PyTuple_Type,&cov_fun_xa_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.diag_call to C/Fortran array" );
  } else {
    x = (double *)(PyArray_DATA(capi_x_tmp));

  /* Processing variable cov_fun */
if(F2PyCapsule_Check(cov_fun_capi)) {
  cov_fun_cptr = F2PyCapsule_AsVoidPtr(cov_fun_capi);
} else {
  cov_fun_cptr = cb_cov_fun_in_diag_call__user__routines;
}

  cov_fun_nofargs_capi = cb_cov_fun_in_diag_call__user__routines_nofargs;
  if (create_cb_arglist(cov_fun_capi,cov_fun_xa_capi,1,0,&cb_cov_fun_in_diag_call__user__routines_nofargs,&cov_fun_args_capi,"failed in processing argument list for call-back cov_fun.")) {
    jmp_buf cov_fun_jmpbuf;
    CFUNCSMESS("Saving jmpbuf for `cov_fun`.\n");
    SWAP(cov_fun_capi,cb_cov_fun_in_diag_call__user__routines_capi,PyObject);
    SWAP(cov_fun_args_capi,cb_cov_fun_in_diag_call__user__routines_args_capi,PyTupleObject);
    memcpy(&cov_fun_jmpbuf,&cb_cov_fun_in_diag_call__user__routines_jmpbuf,sizeof(jmp_buf));
  /* Processing variable n */
  n = shape(x,0);
  CHECKSCALAR(shape(x,0)==n,"shape(x,0)==n","hidden n","diag_call:n=%d",n) {
  /* Processing variable v */
  v_Dims[0]=n;
  capi_v_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_v_tmp = array_from_pyobj(NPY_DOUBLE,v_Dims,v_Rank,capi_v_intent,Py_None);
  if (capi_v_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `v' of linalg_utils.diag_call to C/Fortran array" );
  } else {
    v = (double *)(PyArray_DATA(capi_v_tmp));

  /* Processing variable ndim */
  ndim = shape(x,1);
  CHECKSCALAR(shape(x,1)==ndim,"shape(x,1)==ndim","hidden ndim","diag_call:ndim=%d",ndim) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
    if ((setjmp(cb_cov_fun_in_diag_call__user__routines_jmpbuf))) {
      f2py_success = 0;
    } else {
        (*f2py_func)(x,&n,&ndim,v,cov_fun_cptr);
    }
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("N",capi_v_tmp);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(x,1)==ndim)*/
  /* End of cleaning variable ndim */
  }  /*if (capi_v_tmp == NULL) ... else of v*/
  /* End of cleaning variable v */
  } /*CHECKSCALAR(shape(x,0)==n)*/
  /* End of cleaning variable n */
    CFUNCSMESS("Restoring jmpbuf for `cov_fun`.\n");
    cb_cov_fun_in_diag_call__user__routines_capi = cov_fun_capi;
    Py_DECREF(cb_cov_fun_in_diag_call__user__routines_args_capi);
    cb_cov_fun_in_diag_call__user__routines_args_capi = cov_fun_args_capi;
    cb_cov_fun_in_diag_call__user__routines_nofargs = cov_fun_nofargs_capi;
    memcpy(&cb_cov_fun_in_diag_call__user__routines_jmpbuf,&cov_fun_jmpbuf,sizeof(jmp_buf));
  }
  /* End of cleaning variable cov_fun */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/****************************** end of diag_call ******************************/

/****************************** basis_diag_call ******************************/
static char doc_f2py_rout_linalg_utils_basis_diag_call[] = "\
v = basis_diag_call(basis_x)\n\nWrapper for ``basis_diag_call``.\
\n\nParameters\n----------\n"
"basis_x : input rank-2 array('d') with bounds (nbas,n)\n"
"\nReturns\n-------\n"
"v : rank-1 array('d') with bounds (n)";
/* extern void F_FUNC_US(basis_diag_call,BASIS_DIAG_CALL)(double*,double*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_basis_diag_call(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *basis_x = NULL;
  npy_intp basis_x_Dims[2] = {-1, -1};
  const int basis_x_Rank = 2;
  PyArrayObject *capi_basis_x_tmp = NULL;
  int capi_basis_x_intent = 0;
  PyObject *basis_x_capi = Py_None;
  double *v = NULL;
  npy_intp v_Dims[1] = {-1};
  const int v_Rank = 1;
  PyArrayObject *capi_v_tmp = NULL;
  int capi_v_intent = 0;
  int n = 0;
  int nbas = 0;
  static char *capi_kwlist[] = {"basis_x",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.basis_diag_call",\
    capi_kwlist,&basis_x_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable basis_x */
  ;
  capi_basis_x_intent |= F2PY_INTENT_IN;
  capi_basis_x_tmp = array_from_pyobj(NPY_DOUBLE,basis_x_Dims,basis_x_Rank,capi_basis_x_intent,basis_x_capi);
  if (capi_basis_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `basis_x' of linalg_utils.basis_diag_call to C/Fortran array" );
  } else {
    basis_x = (double *)(PyArray_DATA(capi_basis_x_tmp));

  /* Processing variable n */
  n = shape(basis_x,1);
  CHECKSCALAR(shape(basis_x,1)==n,"shape(basis_x,1)==n","hidden n","basis_diag_call:n=%d",n) {
  /* Processing variable nbas */
  nbas = shape(basis_x,0);
  CHECKSCALAR(shape(basis_x,0)==nbas,"shape(basis_x,0)==nbas","hidden nbas","basis_diag_call:nbas=%d",nbas) {
  /* Processing variable v */
  v_Dims[0]=n;
  capi_v_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_v_tmp = array_from_pyobj(NPY_DOUBLE,v_Dims,v_Rank,capi_v_intent,Py_None);
  if (capi_v_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `v' of linalg_utils.basis_diag_call to C/Fortran array" );
  } else {
    v = (double *)(PyArray_DATA(capi_v_tmp));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
        (*f2py_func)(basis_x,v,&n,&nbas);
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("N",capi_v_tmp);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  }  /*if (capi_v_tmp == NULL) ... else of v*/
  /* End of cleaning variable v */
  } /*CHECKSCALAR(shape(basis_x,0)==nbas)*/
  /* End of cleaning variable nbas */
  } /*CHECKSCALAR(shape(basis_x,1)==n)*/
  /* End of cleaning variable n */
  if((PyObject *)capi_basis_x_tmp!=basis_x_capi) {
    Py_XDECREF(capi_basis_x_tmp); }
  }  /*if (capi_basis_x_tmp == NULL) ... else of basis_x*/
  /* End of cleaning variable basis_x */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/*************************** end of basis_diag_call ***************************/

/******************************* gp_array_logp *******************************/
static char doc_f2py_rout_linalg_utils_gp_array_logp[] = "\
like = gp_array_logp(x,mu,sig,[overwrite_x,overwrite_mu])\n\nWrapper for ``gp_array_logp``.\
\n\nParameters\n----------\n"
"x : input rank-1 array('d') with bounds (n)\n"
"mu : input rank-1 array('d') with bounds (n)\n"
"sig : input rank-2 array('d') with bounds (n,n)\n"
"\nOther Parameters\n----------------\n"
"overwrite_x : input int, optional\n    Default: 0\n"
"overwrite_mu : input int, optional\n    Default: 0\n"
"\nReturns\n-------\n"
"like : float";
/* extern void F_FUNC_US(gp_array_logp,GP_ARRAY_LOGP)(double*,double*,double*,int*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_gp_array_logp(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,double*,int*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  int capi_overwrite_x = 0;
  PyObject *x_capi = Py_None;
  double *mu = NULL;
  npy_intp mu_Dims[1] = {-1};
  const int mu_Rank = 1;
  PyArrayObject *capi_mu_tmp = NULL;
  int capi_mu_intent = 0;
  int capi_overwrite_mu = 0;
  PyObject *mu_capi = Py_None;
  double *sig = NULL;
  npy_intp sig_Dims[2] = {-1, -1};
  const int sig_Rank = 2;
  PyArrayObject *capi_sig_tmp = NULL;
  int capi_sig_intent = 0;
  PyObject *sig_capi = Py_None;
  int n = 0;
  double like = 0;
  int info = 0;
  static char *capi_kwlist[] = {"x","mu","sig","overwrite_x","overwrite_mu",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOO|ii:linalg_utils.gp_array_logp",\
    capi_kwlist,&x_capi,&mu_capi,&sig_capi,&capi_overwrite_x,&capi_overwrite_mu))
    return NULL;
/*frompyobj*/
  /* Processing variable info */
  /* Processing variable x */
  capi_x_intent |= (capi_overwrite_x?0:F2PY_INTENT_COPY);
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.gp_array_logp to C/Fortran array" );
  } else {
    x = (double *)(PyArray_DATA(capi_x_tmp));

  /* Processing variable like */
  /* Processing variable n */
  n = len(x);
  CHECKSCALAR(len(x)>=n,"len(x)>=n","hidden n","gp_array_logp:n=%d",n) {
  /* Processing variable mu */
  capi_mu_intent |= (capi_overwrite_mu?0:F2PY_INTENT_COPY);
  mu_Dims[0]=n;
  capi_mu_intent |= F2PY_INTENT_IN;
  capi_mu_tmp = array_from_pyobj(NPY_DOUBLE,mu_Dims,mu_Rank,capi_mu_intent,mu_capi);
  if (capi_mu_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `mu' of linalg_utils.gp_array_logp to C/Fortran array" );
  } else {
    mu = (double *)(PyArray_DATA(capi_mu_tmp));

  /* Processing variable sig */
  sig_Dims[0]=n,sig_Dims[1]=n;
  capi_sig_intent |= F2PY_INTENT_IN;
  capi_sig_tmp = array_from_pyobj(NPY_DOUBLE,sig_Dims,sig_Rank,capi_sig_intent,sig_capi);
  if (capi_sig_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 3rd argument `sig' of linalg_utils.gp_array_logp to C/Fortran array" );
  } else {
    sig = (double *)(PyArray_DATA(capi_sig_tmp));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(x,mu,sig,&n,&like,&info);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("d",like);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_sig_tmp!=sig_capi) {
    Py_XDECREF(capi_sig_tmp); }
  }  /*if (capi_sig_tmp == NULL) ... else of sig*/
  /* End of cleaning variable sig */
  if((PyObject *)capi_mu_tmp!=mu_capi) {
    Py_XDECREF(capi_mu_tmp); }
  }  /*if (capi_mu_tmp == NULL) ... else of mu*/
  /* End of cleaning variable mu */
  } /*CHECKSCALAR(len(x)>=n)*/
  /* End of cleaning variable n */
  /* End of cleaning variable like */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
  /* End of cleaning variable info */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/**************************** end of gp_array_logp ****************************/

/************************************ asqs ************************************/
static char doc_f2py_rout_linalg_utils_asqs[] = "\
asqs(c,s,[cmin,cmax])\n\nWrapper for ``asqs``.\
\n\nParameters\n----------\n"
"c : input rank-2 array('d') with bounds (nx,ny)\n"
"s :  rank-1 array('d') with bounds (ny)\n"
"\nOther Parameters\n----------------\n"
"cmin : input int, optional\n    Default: 0\n"
"cmax : input int, optional\n    Default: -1";
/* extern void F_FUNC(asqs,ASQS)(double*,double*,int*,int*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_asqs(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,int*,int*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *c = NULL;
  npy_intp c_Dims[2] = {-1, -1};
  const int c_Rank = 2;
  PyArrayObject *capi_c_tmp = NULL;
  int capi_c_intent = 0;
  PyObject *c_capi = Py_None;
  double *s = NULL;
  npy_intp s_Dims[1] = {-1};
  const int s_Rank = 1;
  PyArrayObject *capi_s_tmp = NULL;
  int capi_s_intent = 0;
  PyObject *s_capi = Py_None;
  int nx = 0;
  int ny = 0;
  int cmin = 0;
  PyObject *cmin_capi = Py_None;
  int cmax = 0;
  PyObject *cmax_capi = Py_None;
  static char *capi_kwlist[] = {"c","s","cmin","cmax",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO|OO:linalg_utils.asqs",\
    capi_kwlist,&c_capi,&s_capi,&cmin_capi,&cmax_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable c */
  ;
  capi_c_intent |= F2PY_INTENT_IN;
  capi_c_tmp = array_from_pyobj(NPY_DOUBLE,c_Dims,c_Rank,capi_c_intent,c_capi);
  if (capi_c_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `c' of linalg_utils.asqs to C/Fortran array" );
  } else {
    c = (double *)(PyArray_DATA(capi_c_tmp));

  /* Processing variable cmin */
  if (cmin_capi == Py_None) cmin = 0; else
    f2py_success = int_from_pyobj(&cmin,cmin_capi,"linalg_utils.asqs() 1st keyword (cmin) can't be converted to int");
  if (f2py_success) {
  /* Processing variable cmax */
  if (cmax_capi == Py_None) cmax = -1; else
    f2py_success = int_from_pyobj(&cmax,cmax_capi,"linalg_utils.asqs() 2nd keyword (cmax) can't be converted to int");
  if (f2py_success) {
  /* Processing variable nx */
  nx = shape(c,0);
  CHECKSCALAR(shape(c,0)==nx,"shape(c,0)==nx","hidden nx","asqs:nx=%d",nx) {
  /* Processing variable ny */
  ny = shape(c,1);
  CHECKSCALAR(shape(c,1)==ny,"shape(c,1)==ny","hidden ny","asqs:ny=%d",ny) {
  /* Processing variable s */
  s_Dims[0]=ny;
  capi_s_intent |= F2PY_INTENT_INPLACE;
  capi_s_tmp = array_from_pyobj(NPY_DOUBLE,s_Dims,s_Rank,capi_s_intent,s_capi);
  if (capi_s_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `s' of linalg_utils.asqs to C/Fortran array" );
  } else {
    s = (double *)(PyArray_DATA(capi_s_tmp));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(c,s,&nx,&ny,&cmin,&cmax);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_s_tmp!=s_capi) {
    Py_XDECREF(capi_s_tmp); }
  }  /*if (capi_s_tmp == NULL) ... else of s*/
  /* End of cleaning variable s */
  } /*CHECKSCALAR(shape(c,1)==ny)*/
  /* End of cleaning variable ny */
  } /*CHECKSCALAR(shape(c,0)==nx)*/
  /* End of cleaning variable nx */
  } /*if (f2py_success) of cmax*/
  /* End of cleaning variable cmax */
  } /*if (f2py_success) of cmin*/
  /* End of cleaning variable cmin */
  if((PyObject *)capi_c_tmp!=c_capi) {
    Py_XDECREF(capi_c_tmp); }
  }  /*if (capi_c_tmp == NULL) ... else of c*/
  /* End of cleaning variable c */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/******************************** end of asqs ********************************/

/********************************* dcopy_wrap *********************************/
static char doc_f2py_rout_linalg_utils_dcopy_wrap[] = "\
dcopy_wrap(x,y)\n\nWrapper for ``dcopy_wrap``.\
\n\nParameters\n----------\n"
"x : input rank-1 array('d') with bounds (nx)\n"
"y :  rank-1 array('d') with bounds (nx)";
/* extern void F_FUNC_US(dcopy_wrap,DCOPY_WRAP)(double*,double*,int*); */
static PyObject *f2py_rout_linalg_utils_dcopy_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *x = NULL;
  npy_intp x_Dims[1] = {-1};
  const int x_Rank = 1;
  PyArrayObject *capi_x_tmp = NULL;
  int capi_x_intent = 0;
  PyObject *x_capi = Py_None;
  double *y = NULL;
  npy_intp y_Dims[1] = {-1};
  const int y_Rank = 1;
  PyArrayObject *capi_y_tmp = NULL;
  int capi_y_intent = 0;
  PyObject *y_capi = Py_None;
  int nx = 0;
  static char *capi_kwlist[] = {"x","y",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO:linalg_utils.dcopy_wrap",\
    capi_kwlist,&x_capi,&y_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable x */
  ;
  capi_x_intent |= F2PY_INTENT_IN;
  capi_x_tmp = array_from_pyobj(NPY_DOUBLE,x_Dims,x_Rank,capi_x_intent,x_capi);
  if (capi_x_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `x' of linalg_utils.dcopy_wrap to C/Fortran array" );
  } else {
    x = (double *)(PyArray_DATA(capi_x_tmp));

  /* Processing variable nx */
  nx = len(x);
  CHECKSCALAR(len(x)>=nx,"len(x)>=nx","hidden nx","dcopy_wrap:nx=%d",nx) {
  /* Processing variable y */
  y_Dims[0]=nx;
  capi_y_intent |= F2PY_INTENT_INPLACE;
  capi_y_tmp = array_from_pyobj(NPY_DOUBLE,y_Dims,y_Rank,capi_y_intent,y_capi);
  if (capi_y_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `y' of linalg_utils.dcopy_wrap to C/Fortran array" );
  } else {
    y = (double *)(PyArray_DATA(capi_y_tmp));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(x,y,&nx);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  if((PyObject *)capi_y_tmp!=y_capi) {
    Py_XDECREF(capi_y_tmp); }
  }  /*if (capi_y_tmp == NULL) ... else of y*/
  /* End of cleaning variable y */
  } /*CHECKSCALAR(len(x)>=nx)*/
  /* End of cleaning variable nx */
  if((PyObject *)capi_x_tmp!=x_capi) {
    Py_XDECREF(capi_x_tmp); }
  }  /*if (capi_x_tmp == NULL) ... else of x*/
  /* End of cleaning variable x */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dcopy_wrap *****************************/

/********************************* dtrmm_wrap *********************************/
static char doc_f2py_rout_linalg_utils_dtrmm_wrap[] = "\
dtrmm_wrap(a,b,side,transa,uplo,alpha)\n\nWrapper for ``dtrmm_wrap``.\
\n\nParameters\n----------\n"
"a : input rank-2 array('d') with bounds (m,m)\n"
"b :  rank-2 array('d') with bounds (m,n)\n"
"side : input string(len=1)\n"
"transa : input string(len=1)\n"
"uplo : input string(len=1)\n"
"alpha : input float";
/* extern void F_FUNC_US(dtrmm_wrap,DTRMM_WRAP)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtrmm_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int m = 0;
  int n = 0;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  string side = NULL;
  int slen(side);
  PyObject *side_capi = Py_None;
  string transa = NULL;
  int slen(transa);
  PyObject *transa_capi = Py_None;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  static char *capi_kwlist[] = {"a","b","side","transa","uplo","alpha",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO:linalg_utils.dtrmm_wrap",\
    capi_kwlist,&a_capi,&b_capi,&side_capi,&transa_capi,&uplo_capi,&alpha_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 5th argument `uplo' of linalg_utils.dtrmm_wrap to C string");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dtrmm_wrap() 6th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable transa */
  slen(transa) = 1;
  f2py_success = string_from_pyobj(&transa,&slen(transa),"",transa_capi,"string_from_pyobj failed in converting 4th argument `transa' of linalg_utils.dtrmm_wrap to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `a' of linalg_utils.dtrmm_wrap to C/Fortran array" );
  } else {
    a = (double *)(PyArray_DATA(capi_a_tmp));

  /* Processing variable side */
  slen(side) = 1;
  f2py_success = string_from_pyobj(&side,&slen(side),"",side_capi,"string_from_pyobj failed in converting 3rd argument `side' of linalg_utils.dtrmm_wrap to C string");
  if (f2py_success) {
  /* Processing variable m */
  m = shape(a,0);
  CHECKSCALAR(shape(a,0)==m,"shape(a,0)==m","hidden m","dtrmm_wrap:m=%d",m) {
  /* Processing variable b */
  b_Dims[0]=m;
  capi_b_intent |= F2PY_INTENT_INPLACE;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `b' of linalg_utils.dtrmm_wrap to C/Fortran array" );
  } else {
    b = (double *)(PyArray_DATA(capi_b_tmp));

  /* Processing variable n */
  n = shape(b,1);
  CHECKSCALAR(shape(b,1)==n,"shape(b,1)==n","hidden n","dtrmm_wrap:n=%d",n) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(&m,&n,a,b,side,transa,uplo,&alpha,slen(side),slen(transa),slen(uplo));
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(b,1)==n)*/
  /* End of cleaning variable n */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  } /*CHECKSCALAR(shape(a,0)==m)*/
  /* End of cleaning variable m */
    STRINGFREE(side);
  }  /*if (f2py_success) of side*/
  /* End of cleaning variable side */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(transa);
  }  /*if (f2py_success) of transa*/
  /* End of cleaning variable transa */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dtrmm_wrap *****************************/

/********************************* dtrsm_wrap *********************************/
static char doc_f2py_rout_linalg_utils_dtrsm_wrap[] = "\
dtrsm_wrap(a,b,side,transa,uplo,alpha)\n\nWrapper for ``dtrsm_wrap``.\
\n\nParameters\n----------\n"
"a : input rank-2 array('d') with bounds (m,m)\n"
"b :  rank-2 array('d') with bounds (m,n)\n"
"side : input string(len=1)\n"
"transa : input string(len=1)\n"
"uplo : input string(len=1)\n"
"alpha : input float";
/* extern void F_FUNC_US(dtrsm_wrap,DTRSM_WRAP)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t); */
static PyObject *f2py_rout_linalg_utils_dtrsm_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,double*,double*,string,string,string,double*,size_t,size_t,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  int m = 0;
  int n = 0;
  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  string side = NULL;
  int slen(side);
  PyObject *side_capi = Py_None;
  string transa = NULL;
  int slen(transa);
  PyObject *transa_capi = Py_None;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  double alpha = 0;
  PyObject *alpha_capi = Py_None;
  static char *capi_kwlist[] = {"a","b","side","transa","uplo","alpha",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OOOOOO:linalg_utils.dtrsm_wrap",\
    capi_kwlist,&a_capi,&b_capi,&side_capi,&transa_capi,&uplo_capi,&alpha_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 5th argument `uplo' of linalg_utils.dtrsm_wrap to C string");
  if (f2py_success) {
  /* Processing variable alpha */
    f2py_success = double_from_pyobj(&alpha,alpha_capi,"linalg_utils.dtrsm_wrap() 6th argument (alpha) can't be converted to double");
  if (f2py_success) {
  /* Processing variable transa */
  slen(transa) = 1;
  f2py_success = string_from_pyobj(&transa,&slen(transa),"",transa_capi,"string_from_pyobj failed in converting 4th argument `transa' of linalg_utils.dtrsm_wrap to C string");
  if (f2py_success) {
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_IN;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `a' of linalg_utils.dtrsm_wrap to C/Fortran array" );
  } else {
    a = (double *)(PyArray_DATA(capi_a_tmp));

  /* Processing variable side */
  slen(side) = 1;
  f2py_success = string_from_pyobj(&side,&slen(side),"",side_capi,"string_from_pyobj failed in converting 3rd argument `side' of linalg_utils.dtrsm_wrap to C string");
  if (f2py_success) {
  /* Processing variable m */
  m = shape(a,0);
  CHECKSCALAR(shape(a,0)==m,"shape(a,0)==m","hidden m","dtrsm_wrap:m=%d",m) {
  /* Processing variable b */
  b_Dims[0]=m;
  capi_b_intent |= F2PY_INTENT_INPLACE;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `b' of linalg_utils.dtrsm_wrap to C/Fortran array" );
  } else {
    b = (double *)(PyArray_DATA(capi_b_tmp));

  /* Processing variable n */
  n = shape(b,1);
  CHECKSCALAR(shape(b,1)==n,"shape(b,1)==n","hidden n","dtrsm_wrap:n=%d",n) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(&m,&n,a,b,side,transa,uplo,&alpha,slen(side),slen(transa),slen(uplo));
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("");
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  } /*CHECKSCALAR(shape(b,1)==n)*/
  /* End of cleaning variable n */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  } /*CHECKSCALAR(shape(a,0)==m)*/
  /* End of cleaning variable m */
    STRINGFREE(side);
  }  /*if (f2py_success) of side*/
  /* End of cleaning variable side */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
    STRINGFREE(transa);
  }  /*if (f2py_success) of transa*/
  /* End of cleaning variable transa */
  } /*if (f2py_success) of alpha*/
  /* End of cleaning variable alpha */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dtrsm_wrap *****************************/

/******************************** dpotrf_wrap ********************************/
static char doc_f2py_rout_linalg_utils_dpotrf_wrap[] = "\
info = dpotrf_wrap(a)\n\nWrapper for ``dpotrf_wrap``.\
\n\nParameters\n----------\n"
"a :  rank-2 array('d') with bounds (n,n)\n"
"\nReturns\n-------\n"
"info : int";
/* extern void F_FUNC_US(dpotrf_wrap,DPOTRF_WRAP)(double*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_dpotrf_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int n = 0;
  int info = 0;
  static char *capi_kwlist[] = {"a",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.dpotrf_wrap",\
    capi_kwlist,&a_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable info */
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_INPLACE;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `a' of linalg_utils.dpotrf_wrap to C/Fortran array" );
  } else {
    a = (double *)(PyArray_DATA(capi_a_tmp));

  /* Processing variable n */
  n = shape(a,0);
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(a,&n,&info);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable n */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
  /* End of cleaning variable info */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dpotrf_wrap *****************************/

/********************************* dchdc_wrap *********************************/
static char doc_f2py_rout_linalg_utils_dchdc_wrap[] = "\
piv,info = dchdc_wrap(a)\n\nWrapper for ``dchdc_wrap``.\
\n\nParameters\n----------\n"
"a :  rank-2 array('d') with bounds (p,p)\n"
"\nReturns\n-------\n"
"piv : rank-1 array('i') with bounds (p)\n"
"info : int";
/* extern void F_FUNC_US(dchdc_wrap,DCHDC_WRAP)(double*,int*,double*,int*,int*); */
static PyObject *f2py_rout_linalg_utils_dchdc_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,int*,double*,int*,int*)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *a = NULL;
  npy_intp a_Dims[2] = {-1, -1};
  const int a_Rank = 2;
  PyArrayObject *capi_a_tmp = NULL;
  int capi_a_intent = 0;
  PyObject *a_capi = Py_None;
  int p = 0;
  double *work = NULL;
  npy_intp work_Dims[1] = {-1};
  const int work_Rank = 1;
  PyArrayObject *capi_work_tmp = NULL;
  int capi_work_intent = 0;
  int *piv = NULL;
  npy_intp piv_Dims[1] = {-1};
  const int piv_Rank = 1;
  PyArrayObject *capi_piv_tmp = NULL;
  int capi_piv_intent = 0;
  int info = 0;
  static char *capi_kwlist[] = {"a",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "O:linalg_utils.dchdc_wrap",\
    capi_kwlist,&a_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable a */
  ;
  capi_a_intent |= F2PY_INTENT_INPLACE;
  capi_a_tmp = array_from_pyobj(NPY_DOUBLE,a_Dims,a_Rank,capi_a_intent,a_capi);
  if (capi_a_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `a' of linalg_utils.dchdc_wrap to C/Fortran array" );
  } else {
    a = (double *)(PyArray_DATA(capi_a_tmp));

  /* Processing variable info */
  /* Processing variable p */
  p = shape(a,0);
  CHECKSCALAR(shape(a,0)==p,"shape(a,0)==p","hidden p","dchdc_wrap:p=%d",p) {
  /* Processing variable piv */
  piv_Dims[0]=p;
  capi_piv_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
  capi_piv_tmp = array_from_pyobj(NPY_INT,piv_Dims,piv_Rank,capi_piv_intent,Py_None);
  if (capi_piv_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `piv' of linalg_utils.dchdc_wrap to C/Fortran array" );
  } else {
    piv = (int *)(PyArray_DATA(capi_piv_tmp));

  /* Processing variable work */
  work_Dims[0]=p;
  capi_work_intent |= F2PY_INTENT_HIDE;
  capi_work_tmp = array_from_pyobj(NPY_DOUBLE,work_Dims,work_Rank,capi_work_intent,Py_None);
  if (capi_work_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting hidden `work' of linalg_utils.dchdc_wrap to C/Fortran array" );
  } else {
    work = (double *)(PyArray_DATA(capi_work_tmp));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(a,&p,work,piv,&info);
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("Ni",capi_piv_tmp,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    Py_XDECREF(capi_work_tmp);
  }  /*if (capi_work_tmp == NULL) ... else of work*/
  /* End of cleaning variable work */
  }  /*if (capi_piv_tmp == NULL) ... else of piv*/
  /* End of cleaning variable piv */
  } /*CHECKSCALAR(shape(a,0)==p)*/
  /* End of cleaning variable p */
  /* End of cleaning variable info */
  if((PyObject *)capi_a_tmp!=a_capi) {
    Py_XDECREF(capi_a_tmp); }
  }  /*if (capi_a_tmp == NULL) ... else of a*/
  /* End of cleaning variable a */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dchdc_wrap *****************************/

/******************************** dpotrs_wrap ********************************/
static char doc_f2py_rout_linalg_utils_dpotrs_wrap[] = "\
info = dpotrs_wrap(chol_fac,b,[uplo])\n\nWrapper for ``dpotrs_wrap``.\
\n\nParameters\n----------\n"
"chol_fac : input rank-2 array('d') with bounds (n,n)\n"
"b :  rank-2 array('d') with bounds (n,m)\n"
"\nOther Parameters\n----------------\n"
"uplo : input string(len=1)\n"
"\nReturns\n-------\n"
"info : int";
/* extern void F_FUNC_US(dpotrs_wrap,DPOTRS_WRAP)(double*,double*,int*,int*,int*,string,size_t); */
static PyObject *f2py_rout_linalg_utils_dpotrs_wrap(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(double*,double*,int*,int*,int*,string,size_t)) {
  PyObject * volatile capi_buildvalue = NULL;
  volatile int f2py_success = 1;
/*decl*/

  double *chol_fac = NULL;
  npy_intp chol_fac_Dims[2] = {-1, -1};
  const int chol_fac_Rank = 2;
  PyArrayObject *capi_chol_fac_tmp = NULL;
  int capi_chol_fac_intent = 0;
  PyObject *chol_fac_capi = Py_None;
  double *b = NULL;
  npy_intp b_Dims[2] = {-1, -1};
  const int b_Rank = 2;
  PyArrayObject *capi_b_tmp = NULL;
  int capi_b_intent = 0;
  PyObject *b_capi = Py_None;
  int info = 0;
  int n = 0;
  int m = 0;
  string uplo = NULL;
  int slen(uplo);
  PyObject *uplo_capi = Py_None;
  static char *capi_kwlist[] = {"chol_fac","b","uplo",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
  if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
    "OO|O:linalg_utils.dpotrs_wrap",\
    capi_kwlist,&chol_fac_capi,&b_capi,&uplo_capi))
    return NULL;
/*frompyobj*/
  /* Processing variable info */
  /* Processing variable chol_fac */
  ;
  capi_chol_fac_intent |= F2PY_INTENT_IN;
  capi_chol_fac_tmp = array_from_pyobj(NPY_DOUBLE,chol_fac_Dims,chol_fac_Rank,capi_chol_fac_intent,chol_fac_capi);
  if (capi_chol_fac_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 1st argument `chol_fac' of linalg_utils.dpotrs_wrap to C/Fortran array" );
  } else {
    chol_fac = (double *)(PyArray_DATA(capi_chol_fac_tmp));

  /* Processing variable uplo */
  slen(uplo) = 1;
  f2py_success = string_from_pyobj(&uplo,&slen(uplo),"",uplo_capi,"string_from_pyobj failed in converting 1st keyword `uplo' of linalg_utils.dpotrs_wrap to C string");
  if (f2py_success) {
  /* Processing variable n */
  n = shape(chol_fac,0);
  /* Processing variable b */
  b_Dims[0]=n;
  capi_b_intent |= F2PY_INTENT_INPLACE;
  capi_b_tmp = array_from_pyobj(NPY_DOUBLE,b_Dims,b_Rank,capi_b_intent,b_capi);
  if (capi_b_tmp == NULL) {
    if (!PyErr_Occurred())
      PyErr_SetString(linalg_utils_error,"failed in converting 2nd argument `b' of linalg_utils.dpotrs_wrap to C/Fortran array" );
  } else {
    b = (double *)(PyArray_DATA(capi_b_tmp));

  /* Processing variable m */
  m = shape(b,1);
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
      Py_BEGIN_ALLOW_THREADS
        (*f2py_func)(chol_fac,b,&info,&n,&m,uplo,slen(uplo));
      Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
    if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
    CFUNCSMESS("Building return value.\n");
    capi_buildvalue = Py_BuildValue("i",info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
    } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
  /* End of cleaning variable m */
  if((PyObject *)capi_b_tmp!=b_capi) {
    Py_XDECREF(capi_b_tmp); }
  }  /*if (capi_b_tmp == NULL) ... else of b*/
  /* End of cleaning variable b */
  /* End of cleaning variable n */
    STRINGFREE(uplo);
  }  /*if (f2py_success) of uplo*/
  /* End of cleaning variable uplo */
  if((PyObject *)capi_chol_fac_tmp!=chol_fac_capi) {
    Py_XDECREF(capi_chol_fac_tmp); }
  }  /*if (capi_chol_fac_tmp == NULL) ... else of chol_fac*/
  /* End of cleaning variable chol_fac */
  /* End of cleaning variable info */
/*end of cleanupfrompyobj*/
  if (capi_buildvalue == NULL) {
/*routdebugfailure*/
  } else {
/*routdebugleave*/
  }
  CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
  return capi_buildvalue;
}
/***************************** end of dpotrs_wrap *****************************/
/*eof body*/

/******************* See f2py2e/f90mod_rules.py: buildhooks *******************/
/*need_f90modhooks*/

/************** See f2py2e/rules.py: module_rules['modulebody'] **************/

/******************* See f2py2e/common_rules.py: buildhooks *******************/

/*need_commonhooks*/

/**************************** See f2py2e/rules.py ****************************/

static FortranDataDef f2py_routine_defs[] = {
  {"remove_duplicates",-1,{{-1}},0,(char *)F_FUNC_US(remove_duplicates,REMOVE_DUPLICATES),(f2py_init_func)f2py_rout_linalg_utils_remove_duplicates,doc_f2py_rout_linalg_utils_remove_duplicates},
  {"check_repeats",-1,{{-1}},0,(char *)F_FUNC_US(check_repeats,CHECK_REPEATS),(f2py_init_func)f2py_rout_linalg_utils_check_repeats,doc_f2py_rout_linalg_utils_check_repeats},
  {"diag_call",-1,{{-1}},0,(char *)F_FUNC_US(diag_call,DIAG_CALL),(f2py_init_func)f2py_rout_linalg_utils_diag_call,doc_f2py_rout_linalg_utils_diag_call},
  {"basis_diag_call",-1,{{-1}},0,(char *)F_FUNC_US(basis_diag_call,BASIS_DIAG_CALL),(f2py_init_func)f2py_rout_linalg_utils_basis_diag_call,doc_f2py_rout_linalg_utils_basis_diag_call},
  {"gp_array_logp",-1,{{-1}},0,(char *)F_FUNC_US(gp_array_logp,GP_ARRAY_LOGP),(f2py_init_func)f2py_rout_linalg_utils_gp_array_logp,doc_f2py_rout_linalg_utils_gp_array_logp},
  {"asqs",-1,{{-1}},0,(char *)F_FUNC(asqs,ASQS),(f2py_init_func)f2py_rout_linalg_utils_asqs,doc_f2py_rout_linalg_utils_asqs},
  {"dcopy_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dcopy_wrap,DCOPY_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dcopy_wrap,doc_f2py_rout_linalg_utils_dcopy_wrap},
  {"dtrmm_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dtrmm_wrap,DTRMM_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dtrmm_wrap,doc_f2py_rout_linalg_utils_dtrmm_wrap},
  {"dtrsm_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dtrsm_wrap,DTRSM_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dtrsm_wrap,doc_f2py_rout_linalg_utils_dtrsm_wrap},
  {"dpotrf_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dpotrf_wrap,DPOTRF_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dpotrf_wrap,doc_f2py_rout_linalg_utils_dpotrf_wrap},
  {"dchdc_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dchdc_wrap,DCHDC_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dchdc_wrap,doc_f2py_rout_linalg_utils_dchdc_wrap},
  {"dpotrs_wrap",-1,{{-1}},0,(char *)F_FUNC_US(dpotrs_wrap,DPOTRS_WRAP),(f2py_init_func)f2py_rout_linalg_utils_dpotrs_wrap,doc_f2py_rout_linalg_utils_dpotrs_wrap},

/*eof routine_defs*/
  {NULL}
};

static PyMethodDef f2py_module_methods[] = {

  {NULL,NULL}
};

#if PY_VERSION_HEX >= 0x03000000
static struct PyModuleDef moduledef = {
  PyModuleDef_HEAD_INIT,
  "linalg_utils",
  NULL,
  -1,
  f2py_module_methods,
  NULL,
  NULL,
  NULL,
  NULL
};
#endif

#if PY_VERSION_HEX >= 0x03000000
#define RETVAL m
PyMODINIT_FUNC PyInit_linalg_utils(void) {
#else
#define RETVAL
PyMODINIT_FUNC initlinalg_utils(void) {
#endif
  int i;
  PyObject *m,*d, *s;
#if PY_VERSION_HEX >= 0x03000000
  m = linalg_utils_module = PyModule_Create(&moduledef);
#else
  m = linalg_utils_module = Py_InitModule("linalg_utils", f2py_module_methods);
#endif
  Py_TYPE(&PyFortran_Type) = &PyType_Type;
  import_array();
  if (PyErr_Occurred())
    {PyErr_SetString(PyExc_ImportError, "can't initialize module linalg_utils (failed to import numpy)"); return RETVAL;}
  d = PyModule_GetDict(m);
  s = PyString_FromString("$Revision: $");
  PyDict_SetItemString(d, "__version__", s);
#if PY_VERSION_HEX >= 0x03000000
  s = PyUnicode_FromString(
#else
  s = PyString_FromString(
#endif
    "This module 'linalg_utils' is auto-generated with f2py (version:2).\nFunctions:\n"
"  nr,rf,rt,nu,xu,ui = remove_duplicates(x)\n"
"  f,new_indices,n_new_indices = check_repeats(x,x_sofar,f_sofar)\n"
"  v = diag_call(x,cov_fun,cov_fun_extra_args=())\n"
"  v = basis_diag_call(basis_x)\n"
"  like = gp_array_logp(x,mu,sig,overwrite_x=0,overwrite_mu=0)\n"
"  asqs(c,s,cmin=0,cmax=-1)\n"
"  dcopy_wrap(x,y)\n"
"  dtrmm_wrap(a,b,side,transa,uplo,alpha)\n"
"  dtrsm_wrap(a,b,side,transa,uplo,alpha)\n"
"  info = dpotrf_wrap(a)\n"
"  piv,info = dchdc_wrap(a)\n"
"  info = dpotrs_wrap(chol_fac,b,uplo='')\n"
".");
  PyDict_SetItemString(d, "__doc__", s);
  linalg_utils_error = PyErr_NewException ("linalg_utils.error", NULL, NULL);
  Py_DECREF(s);
  for(i=0;f2py_routine_defs[i].name!=NULL;i++)
    PyDict_SetItemString(d, f2py_routine_defs[i].name,PyFortranObject_NewAsAttr(&f2py_routine_defs[i]));












/*eof initf2pywraphooks*/
/*eof initf90modhooks*/

/*eof initcommonhooks*/


#ifdef F2PY_REPORT_ATEXIT
  if (! PyErr_Occurred())
    on_exit(f2py_report_on_exit,(void*)"linalg_utils");
#endif

  return RETVAL;
}
#ifdef __cplusplus
}
#endif
